<?php

namespace farpointsystems;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'fileTaxReturn' => '\\farpointsystems\\StructType\\FileTaxReturn',
            'RequestHeaderType' => '\\farpointsystems\\StructType\\RequestHeaderType',
            'fileTaxReturnResponse' => '\\farpointsystems\\StructType\\FileTaxReturnResponse',
            'TaxReturnResponseType' => '\\farpointsystems\\StructType\\TaxReturnResponseType',
            'ErrorGroupType' => '\\farpointsystems\\StructType\\ErrorGroupType',
            'ErrorType' => '\\farpointsystems\\StructType\\ErrorType',
            'getSUTPrepayFuelRates' => '\\farpointsystems\\StructType\\GetSUTPrepayFuelRates',
            'getSUTPrepayFuelRatesResponse' => '\\farpointsystems\\StructType\\GetSUTPrepayFuelRatesResponse',
            'FuelRateResponseType' => '\\farpointsystems\\StructType\\FuelRateResponseType',
            'FuelRateType' => '\\farpointsystems\\StructType\\FuelRateType',
            'getSubLocations' => '\\farpointsystems\\StructType\\GetSubLocations',
            'getSubLocationsResponse' => '\\farpointsystems\\StructType\\GetSubLocationsResponse',
            'SubLocationResponseType' => '\\farpointsystems\\StructType\\SubLocationResponseType',
            'ExistingLocationType' => '\\farpointsystems\\StructType\\ExistingLocationType',
            'RequiredAddressType' => '\\farpointsystems\\StructType\\RequiredAddressType',
            'TaxAreaCodeType' => '\\farpointsystems\\StructType\\TaxAreaCodeType',
            'getReturnPackage' => '\\farpointsystems\\StructType\\GetReturnPackage',
            'getReturnPackageResponse' => '\\farpointsystems\\StructType\\GetReturnPackageResponse',
            'ReturnPackageResponseType' => '\\farpointsystems\\StructType\\ReturnPackageResponseType',
            'ReturnPackageFormType' => '\\farpointsystems\\StructType\\ReturnPackageFormType',
            'makePrePayment' => '\\farpointsystems\\StructType\\MakePrePayment',
            'makePrePaymentResponse' => '\\farpointsystems\\StructType\\MakePrePaymentResponse',
            'Ping' => '\\farpointsystems\\StructType\\Ping',
            'PingResponse' => '\\farpointsystems\\StructType\\PingResponse',
        );
    }
}
