<?php

namespace farpointsystems\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ErrorGroupType StructType
 * @subpackage Structs
 */
class ErrorGroupType extends AbstractStructBase
{
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \farpointsystems\StructType\ErrorType[]
     */
    public $Error;
    /**
     * Constructor method for ErrorGroupType
     * @uses ErrorGroupType::setError()
     * @param \farpointsystems\StructType\ErrorType[] $error
     */
    public function __construct(array $error = array())
    {
        $this
            ->setError($error);
    }
    /**
     * Get Error value
     * @return \farpointsystems\StructType\ErrorType[]|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * This method is responsible for validating the values passed to the setError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorForArrayConstraintsFromSetError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $errorGroupTypeErrorItem) {
            // validation for constraint: itemType
            if (!$errorGroupTypeErrorItem instanceof \farpointsystems\StructType\ErrorType) {
                $invalidValues[] = is_object($errorGroupTypeErrorItem) ? get_class($errorGroupTypeErrorItem) : sprintf('%s(%s)', gettype($errorGroupTypeErrorItem), var_export($errorGroupTypeErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Error property can only contain items of type \farpointsystems\StructType\ErrorType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Error value
     * @throws \InvalidArgumentException
     * @param \farpointsystems\StructType\ErrorType[] $error
     * @return \farpointsystems\StructType\ErrorGroupType
     */
    public function setError(array $error = array())
    {
        // validation for constraint: array
        if ('' !== ($errorArrayErrorMessage = self::validateErrorForArrayConstraintsFromSetError($error))) {
            throw new \InvalidArgumentException($errorArrayErrorMessage, __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
    /**
     * Add item to Error value
     * @throws \InvalidArgumentException
     * @param \farpointsystems\StructType\ErrorType $item
     * @return \farpointsystems\StructType\ErrorGroupType
     */
    public function addToError(\farpointsystems\StructType\ErrorType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \farpointsystems\StructType\ErrorType) {
            throw new \InvalidArgumentException(sprintf('The Error property can only contain items of type \farpointsystems\StructType\ErrorType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Error[] = $item;
        return $this;
    }
}
