<?php

namespace farpointsystems\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FuelRateResponseType StructType
 * @subpackage Structs
 */
class FuelRateResponseType extends AbstractStructBase
{
    /**
     * The FuelRate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \farpointsystems\StructType\FuelRateType[]
     */
    public $FuelRate;
    /**
     * Constructor method for FuelRateResponseType
     * @uses FuelRateResponseType::setFuelRate()
     * @param \farpointsystems\StructType\FuelRateType[] $fuelRate
     */
    public function __construct(array $fuelRate = array())
    {
        $this
            ->setFuelRate($fuelRate);
    }
    /**
     * Get FuelRate value
     * @return \farpointsystems\StructType\FuelRateType[]|null
     */
    public function getFuelRate()
    {
        return $this->FuelRate;
    }
    /**
     * This method is responsible for validating the values passed to the setFuelRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFuelRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFuelRateForArrayConstraintsFromSetFuelRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $fuelRateResponseTypeFuelRateItem) {
            // validation for constraint: itemType
            if (!$fuelRateResponseTypeFuelRateItem instanceof \farpointsystems\StructType\FuelRateType) {
                $invalidValues[] = is_object($fuelRateResponseTypeFuelRateItem) ? get_class($fuelRateResponseTypeFuelRateItem) : sprintf('%s(%s)', gettype($fuelRateResponseTypeFuelRateItem), var_export($fuelRateResponseTypeFuelRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FuelRate property can only contain items of type \farpointsystems\StructType\FuelRateType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FuelRate value
     * @throws \InvalidArgumentException
     * @param \farpointsystems\StructType\FuelRateType[] $fuelRate
     * @return \farpointsystems\StructType\FuelRateResponseType
     */
    public function setFuelRate(array $fuelRate = array())
    {
        // validation for constraint: array
        if ('' !== ($fuelRateArrayErrorMessage = self::validateFuelRateForArrayConstraintsFromSetFuelRate($fuelRate))) {
            throw new \InvalidArgumentException($fuelRateArrayErrorMessage, __LINE__);
        }
        $this->FuelRate = $fuelRate;
        return $this;
    }
    /**
     * Add item to FuelRate value
     * @throws \InvalidArgumentException
     * @param \farpointsystems\StructType\FuelRateType $item
     * @return \farpointsystems\StructType\FuelRateResponseType
     */
    public function addToFuelRate(\farpointsystems\StructType\FuelRateType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \farpointsystems\StructType\FuelRateType) {
            throw new \InvalidArgumentException(sprintf('The FuelRate property can only contain items of type \farpointsystems\StructType\FuelRateType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FuelRate[] = $item;
        return $this;
    }
}
